#include <systemc.h>
#include <stdio.h>

#include "decoder.h"

#define step(c) \
	c = true; \
	sc_start( 1); \
	c = false; \
	sc_start( 1);

#define write(n) \
	wr_rd = 1; \
	a = n; \
	step( clk);

#define read(v) \
	wr_rd = 0; \
	step( clk);

int sc_main( int argc, char *argv[])
{
	sc_signal<sc_uint<32> > addr;
	sc_signal<sc_uint<32> > a;
	sc_signal<bool> a1, a2, y1, y2, y3, y4, clk;
	sc_trace_file *tf;
	
	tf = sc_create_vcd_trace_file( "decoder");
	sc_trace( tf, clk, "clk");
	sc_trace( tf, a, "a");
//	sc_trace( tf, a1, "a1");
	sc_trace( tf, y4, "y4");
	sc_trace( tf, y3, "y3");
	sc_trace( tf, y2, "y2");
	sc_trace( tf, y1, "y1");
	
	decoder2 duv1( "duv1");
//	duv1.a1( a1);
//	duv1.a2( a2);
	duv1.a( a);
//	duv1.a( addr);
	duv1.y1( y1);
	duv1.y2( y2);
	duv1.y3( y3);
	duv1.y4( y4);

	sc_start( 1);

	addr = 0;
	a = 0;
	step( clk);
	a = 1;
	step( clk);
	a = 2;
	step( clk);
	a = 3;
	step( clk);
	
	sc_close_vcd_trace_file( tf);

	return EXIT_SUCCESS;
}
