#ifndef __DEV_H__
#define __DEV_H__

#include <systemc.h>

#include "zdff.h"
#include "decoder.h"

#define module dev

SC_MODULE( module) {
public:
	sc_out<sc_uint<32> > dr;
	sc_in<sc_uint<32> > dw;
	sc_in<sc_uint<32> > addr;
	sc_in<bool> cw, cr;
	sc_in<bool> clk;
	
	zdff buf1;
	decoder2 deco1;

	sc_signal<sc_uint<32> > _a;
	sc_signal<sc_uint<32> > _y;
	sc_signal<sc_lv<32> > q;
	sc_signal<bool> enabuf, y2, y3, y4;
	
	void work()
	{
		sc_lv<32> tmp;
		
		tmp = q.read();
		dr = tmp.to_uint();;
	}
	
	SC_CTOR( module) :
	 buf1("buf1"),
	 deco1("deco1")
	{
		deco1.a( addr);
		deco1.y1( enabuf);
		deco1.y2( y2);
		deco1.y3( y3);
		deco1.y4( y4);
		
		buf1.d( dw);
		buf1.q( q);
		buf1.clk( cw);
		buf1.oe( enabuf);
		SC_METHOD( work);
		sensitive << clk;
	}
};

#undef module

#endif/*__DEV_H__*/
