#ifndef __DFF_H__
#define __DFF_H__

#include <systemc.h>

#define module dff

#define N 32

//template <class T, int size = N>
SC_MODULE( module) {
public:
/*	sc_in<T<size> > a;
	sc_out<T<size> > y;*/
	sc_in<sc_uint<N> > a;
	sc_out<sc_uint<N> > y;
	sc_in<bool> clk;

	void work()
	{
		if (clk.posedge())
		{
			int i = a.read();
			printf( "latched data=%02X\n", i);
			y = a.read();
		}
	}

	SC_CTOR( module) {
		SC_METHOD( work);
		sensitive << clk << a;
	}
};

#undef N
#undef module

#endif/*__DFF_H__*/
