#include <systemc.h>
#include <stdio.h>

#include "intf.h"
#include "dev4.h"
//#include "dev3.h"
//#include "dev3.h"
//#include "dev2.h"
//#include "dev1.h"

//#define DO_TRACE

#define init(c) \
	c = false; \
	sc_start( 1); \

#define step(c) \
	c = true; \
	sc_start( 1); \
	c = false; \
	sc_start( 1);

int sc_main( int argc, char *argv[])
{
	sc_signal<sc_lv<32> > data;
	sc_signal<sc_uint<32> > addr;
	sc_signal<sc_uint<32> > a;
	sc_signal<bool> wr_rd, cw, cr;
#ifdef DO_TRACE
	sc_trace_file *tf;
#endif
   	sc_clock clk( "testclock", 10, SC_NS, 0.5, 1, SC_NS);

#ifdef DO_TRACE
	tf = sc_create_vcd_trace_file( "intf");
//	tf = sc_create_wif_trace_file( "intf");
	sc_trace( tf, clk, "clk");
	sc_trace( tf, wr_rd, "wr_rd");
	sc_trace( tf, a, "a");
	sc_trace( tf, addr, "addr");
	sc_trace( tf, data, "data");
	sc_trace( tf, cw, "cw");
	sc_trace( tf, cr, "cr");
#endif
	
	intf intf1( "intf");
	intf1.data( data);
	intf1.cw( cw);
	intf1.cr( cr);
	intf1.clk( clk);
	intf1.addr( addr);
	
	dev dev1( "dev1");
	dev1.data( data);
	dev1.cw( cw);
	dev1.cr( cr);
	dev1.clk( clk);
	dev1.addr( addr);
	
	sc_start();
	
#ifdef DO_TRACE
	sc_close_vcd_trace_file( tf);
//	sc_close_wif_trace_file( tf);
#endif

	return EXIT_SUCCESS;
}
