#include <systemc.h>
#include <stdio.h>

#include "intf.h"
#include "not.h"
#include "counter.h"
#include "dff.h"

#define init(c) \
	c = false; \
	sc_start( 1); \

#define step(c) \
	c = true; \
	sc_start( 1); \
	c = false; \
	sc_start( 1);

int sc_main( int argc, char *argv[])
{
	sc_signal<sc_uint<32> > dw, dr;
	sc_signal<sc_uint<32> > _addr;
	sc_signal<sc_uint<32> > a;
	sc_signal<bool> wr_rd, cw, cr;
	sc_trace_file *tf;
   	sc_clock clk( "testclock", 10, SC_NS, 0.5, 1, SC_NS);

//	tf = sc_create_vcd_trace_file( "intf3");
	tf = sc_create_wif_trace_file( "intf3");
	sc_trace( tf, clk, "clk");
	sc_trace( tf, wr_rd, "wr_rd");
	sc_trace( tf, a, "a");
	sc_trace( tf, _addr, "addr");
	sc_trace( tf, dw, "dw");
	sc_trace( tf, dr, "dr");
	sc_trace( tf, cw, "cw");
	sc_trace( tf, cr, "cr");
	
	intf3 intf1( "intf3");
	intf1.dw( dw);
	intf1.dr( dr);
	intf1.cw( cw);
	intf1.cr( cr);
	intf1.clk( clk);
	intf1.addr( _addr);
	
	dff buf1( "buf1");
	buf1.a( dw);
	buf1.y( a);
	buf1.clk( cw);
	
//	not32 not1( "not1");
//	not1.a( a);
//	not1.y( dr);

	counter counter1( "counter1");
	counter1.a( a);
	counter1.y( dr);
	counter1.clk( clk);

	sc_start();
	
//	sc_close_vcd_trace_file( tf);
	sc_close_wif_trace_file( tf);

	return EXIT_SUCCESS;
}
