#include <systemc.h>
#include <stdio.h>

#include "nand.h"

#define step(c) \
	c = false; \
	sc_start( 1); \
	c = true; \
	sc_start( 1);

#define write(n) \
	wr_rd = 1; \
	a = n; \
	step( clk);

#define read(v) \
	wr_rd = 0; \
	step( clk);

int sc_main( int argc, char *argv[])
{
	sc_signal<bool> a, b, y, clk;
	sc_trace_file *tf;
	
	tf = sc_create_vcd_trace_file( "nand");
	sc_trace( tf, clk, "clk");
	sc_trace( tf, a, "a");
	sc_trace( tf, b, "b");
	sc_trace( tf, y, "y");
	
	nand2 duv1( "duv1");
	duv1.a( a);
	duv1.b( b);
	duv1.y( y);

	a = 0;
	b = 0;
	step( clk);
	a = 1;
	b = 0;
	step( clk);
	a = 0;
	b = 1;
	step( clk);
	a = 1;
	b = 1;
	step( clk);
	
	sc_close_vcd_trace_file( tf);

	return EXIT_SUCCESS;
}
