#include <systemc.h>
#include <stdio.h>

#include "not.h"

#define step(c) \
	c = false; \
	sc_start( 1); \
	c = true; \
	sc_start( 1);

#define write(n) \
	wr_rd = 1; \
	a = n; \
	step( clk);

#define read(v) \
	wr_rd = 0; \
	step( clk);

int sc_main( int argc, char *argv[])
{
	sc_signal<sc_uint<8> > a;
	sc_signal<sc_uint<8> > y;
	sc_signal<bool> clk, wr_rd;
	sc_trace_file *tf;
	
	tf = sc_create_vcd_trace_file( "not");
	sc_trace( tf, clk, "clk");
	sc_trace( tf, wr_rd, "wr_rd");
	sc_trace( tf, a, "a");
	sc_trace( tf, y, "y");
	
	not8 duv1( "duv1");
	duv1.a( a);
	duv1.y( y);

	write( 0xAA);
	write( 0x55);
	
	sc_close_vcd_trace_file( tf);

	return EXIT_SUCCESS;
}
