#ifndef __ROM_H__
#define __ROM_H__

#include <systemc.h>

#define module rom

#define N 32

SC_MODULE( module) {
public:
	sc_in<sc_uint<N> > a;
	sc_out<sc_uint<N> > y;
	sc_in<bool> clk;

#define LEN 10
	int mem[LEN];

	void work()
	{
		if (clk.posedge())
		{
			int i, j;
			
			i = a.read();
			j = mem[i % LEN];
			printf( "read addr=%02X : %02X\n", i, j);
			y = j;
		}
	}

	SC_CTOR( module) {
		int i;
		
		i = 0;
		mem[i++] = 0x55;
		mem[i++] = 0xAA;
		mem[i++] = 0x00;
		printf( "rom content :\n");
		for (i = 0; i < LEN; i++)
		{
			printf( "%02X\n", mem[i]);
		}
		SC_METHOD( work);
		sensitive << clk;
	}
};

#undef N
#undef module

#endif/*__ROM_H__*/
