#include <systemc.h>
#include <stdio.h>

#include "tris.h"
#include "dff.h"

#define step(c) \
	c = true; \
	sc_start( 1); \
	c = false; \
	sc_start( 1);

#define write(n) \
	wr_rd = 1; \
	a = n; \
	step( clk);

#define read(v) \
	wr_rd = 0; \
	step( clk);

int sc_main( int argc, char *argv[])
{
	sc_signal<sc_uint<32> > a, q;
	sc_signal<sc_lv<32> > y;
	sc_signal<bool> oe, clk, clk2;
	sc_trace_file *tf;
	
	tf = sc_create_vcd_trace_file( "tris");
	sc_trace( tf, clk, "clk");
	sc_trace( tf, clk2, "clk2");
	sc_trace( tf, a, "a");
	sc_trace( tf, oe, "oe");
	sc_trace( tf, y, "y");
	
	tris duv1( "duv1");
	duv1.a( q);
	duv1.y( y);
	duv1.oe( oe);
//	duv1.clk( clk);

	dff dff1( "dff1");
	dff1.a( a);
	dff1.y( q);
	dff1.clk( clk2);

	sc_start( 1);

	oe = 1;
	a = 0;
	step( clk);
	a = 1;
	clk2 = 1;
	step( clk);
	clk2 = 0;
	oe = 0;
	a = 2;
	step( clk);
	oe = 1;
	a = 3;
	step( clk);
	clk2 = 1;
	a = 4;
	step( clk);
	
	sc_close_vcd_trace_file( tf);

	return EXIT_SUCCESS;
}
