#include <systemc.h>
#include <stdio.h>

#include "zdff.h"

#define step(c) \
	c = true; \
	sc_start( 1); \
	c = false; \
	sc_start( 1);

#define write(n) \
	wr_rd = 1; \
	a = n; \
	step( clk);

#define read(v) \
	wr_rd = 0; \
	step( clk);

int sc_main( int argc, char *argv[])
{
	sc_signal<sc_uint<32> > d;
	sc_signal<sc_lv<32> > q;
	sc_signal<bool> oe, clk, clk2;
	sc_trace_file *tf;
	
	tf = sc_create_vcd_trace_file( "zdff");
	sc_trace( tf, clk, "clk");
	sc_trace( tf, clk2, "clk2");
	sc_trace( tf, oe, "oe");
	sc_trace( tf, d, "d");
	sc_trace( tf, q, "q");
	
	zdff duv1( "duv1");
	duv1.d( d);
	duv1.q( q);
	duv1.oe( oe);
	duv1.clk( clk2);

	sc_start( 1);

	oe = 1;
	d = 0;
	step( clk);
	d = 1;
	clk2 = 1;
	step( clk);
	clk2 = 0;
	oe = 0;
	d = 2;
	step( clk);
	oe = 1;
	d = 3;
	step( clk);
	clk2 = 1;
	d = 4;
	step( clk);
	
	sc_close_vcd_trace_file( tf);

	return EXIT_SUCCESS;
}
