#ifndef __ZDFF_H__
#define __ZDFF_H__

#include <systemc.h>

#include "dff.h"
#include "tris.h"

#define module zdff

SC_MODULE( module) {
public:
	sc_in<sc_uint<32> > d;
	sc_out<sc_lv<32> > q;
	sc_in<bool> clk, oe;
	
	dff dff1;
	tris tris1;

	sc_signal<sc_uint<32> > _q;
	
	SC_CTOR( module) :
	 dff1( "dff1"),
	 tris1( "tris1")
	{
		dff1.a( d);
		dff1.y( _q);
		dff1.clk( clk);
		tris1.a( _q);
		tris1.y( q);
		tris1.oe( oe);
	}
};

#undef module

#endif/*__ZDFF_H__*/
